include:
  - component: ${CI_SERVER_HOST}/${CI_PROJECT_PATH}/renovate@$CI_COMMIT_SHA
    inputs:
      stage: test-component
      dry_run: "true"
  - component: ${CI_SERVER_HOST}/northamp/cicd-components/semantic-release/semantic-release@~latest
    inputs:
      stage: release
    rules:
      - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH || $CI_COMMIT_BRANCH == "beta"
        when: always
      - when: never

stages:
  - test-component
  - release

# Ensure that a project description exists, because it will be important to display
# the resource in the catalog.
ensure job exists:
  image: badouralix/curl-jq
  stage: test-component
  script:
    - |
      route="${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/pipelines/${CI_PIPELINE_ID}/jobs"
      count=`curl --silent $route | jq 'map(select(.name | contains("renovate"))) | length'`
      if [ "$count" != "1" ]; then
        exit 1
      fi

# Ensure that a project description exists, because it will be important to display
# the resource in the catalog.
check description:
  image: badouralix/curl-jq
  stage: test-component
  script:
    - |
      route="${CI_API_V4_URL}/projects/${CI_PROJECT_ID}"
      desc=`curl --silent $route | jq '.description'`
      if [ "$desc" = "null" ]; then
        echo "Description not set. Please set a projet description"
        exit 1
      else
        echo "Description set"
      fi

# Ensure that a `README.md` exists in the root directory as it represents the
# documentation for the whole components repository.
check readme:
  image: busybox
  stage: test-component
  script: ls README.md || (echo "Please add a README.md file" && exit 1)

# Release is created here